package com.zksy.web.controller.basicData;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmServiceEnterpriseRevenue;
import com.zksy.system.basicData.service.CrmServiceEnterpriseRevenueService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.MergeReadsExcelUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 服务企业营收情况Controller
 *
 * @author sy
 * @date 2024-09-27
 */
@RestController
@RequestMapping("/crmServiceEnterpriseRevenue")
@Api(tags = "服务企业营收情况", description = "服务企业营收情况desc")
public class CrmServiceEnterpriseRevenueController extends BaseController{

    @Autowired
    private CrmServiceEnterpriseRevenueService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "服务企业营收情况搜索getById")
    public CrmServiceEnterpriseRevenue getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "服务企业营收情况分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "服务企业营收情况查询所有")
    public List<CrmServiceEnterpriseRevenue> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增服务企业营收情况
     */
    @PostMapping("/save")
    @ApiOperation(value = "服务企业营收情况新增")
    @Log(title = "新增服务企业营收情况", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmServiceEnterpriseRevenue crmServiceEnterpriseRevenue) {
        return service.save(crmServiceEnterpriseRevenue);
    }

    /**
     * 修改服务企业营收情况
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "服务企业营收情况修改")
    @Log(title = "修改服务企业营收情况", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmServiceEnterpriseRevenue crmServiceEnterpriseRevenue) {
        return service.updateById(crmServiceEnterpriseRevenue);
    }

    /**
     * 导入服务企业营收情况
     */
    @ApiOperation("服务企业营收情况导入")
    @Log(title = "服务企业营收情况", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            //List<CrmServiceEnterpriseRevenue> crmServiceEnterpriseRevenueAll = service.list();
            //excel单元格合并导入
            //参数：文件， 表头列数， 是否读取序号0-读取、1-不读取， 表头占的行数下标从0开始的
            List<Map<String,String>> list = MergeReadsExcelUtil.readExcelToObj(file, CrmServiceEnterpriseRevenue.class.getDeclaredFields().length - 2,1,1,CrmServiceEnterpriseRevenue.class);
            List<CrmServiceEnterpriseRevenue> crmServiceEnterpriseRevenue= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmServiceEnterpriseRevenue>>() {});

            /*if(crmServiceEnterpriseRevenueAll != null && crmServiceEnterpriseRevenueAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }*/
            if(list.size() > 0){
                service.saveBatch(crmServiceEnterpriseRevenue);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("服务企业营收情况导出")
    @Log(title = "服务企业营收情况", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmServiceEnterpriseRevenue> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"服务企业营收情况",wrapperList,CrmServiceEnterpriseRevenue.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "服务企业营收情况", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除服务企业营收情况", notes = "删除服务企业营收情况")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"服务企业营收情况模板");
    }
}

